/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   map_error.c                                        :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: axdubois <axdubois@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2023/08/02 10:06:20 by adjoly            #+#    #+#             */
/*   Updated: 2023/08/02 19:46:23 by axdubois         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "../../includes/Display-h/write.h"
#include "../../includes/utils-h/utils.h"
#include "../../includes/algo-h/algo.h"
#include "../../includes/utils-h/charobj.h"
#include "../../includes/utils-h/fst_line.h"

int	ft_write_error(int file)
{
	write(2, "Map Error", 1);
	close(file);
	return (1);
}

int	ft_atoi(char	*str)
{
	int	i;
	int	result;

	i = 0;
	result = 0;
	while (str[i] >= '0' && str[i] <= '9')
	{
		result = (result * 10) + str[i] - 48;
		i++;
	}
	return (result);
}

int	ft_check_map(int file)
{
	char	*first_line;
	int		line_nb;
	int		i_line_nb;
	int		i;

	i = 1;
	line_nb = ft_len_colum(file);
	first_line = ft_get_first_line(file);
	i_line_nb = ft_atoi(first_line);
	if (i_line_nb != line_nb)
		return (ft_write_error(file));
	while (i < line_nb)
	{
		if (ft_len_line(file, i) != i_line_nb)
			return (ft_write_error(file));
		i++;
	}
	return (0);
}
