/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   header.h                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: adjoly <marvin@42.fr>                      +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2023/07/30 16:51:35 by adjoly            #+#    #+#             */
/*   Updated: 2023/07/30 22:36:51 by tomoron          ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef HEADER_H
# define HEADER_H

# include <stdlib.h>
# include <fcntl.h>
# include <unistd.h>

typedef unsigned long long int	t_ulli;

void	ft_prep_algo(char **dict, char *nbr);
void	ft_nbr_to_letters(char **dict, char *nbr, char **spec_tens, t_ulli l);
void	ft_print_units(char **dict, char unit, t_ulli *len);
void	ft_print_hundreds(char **dict, char *nbr, t_ulli *i, t_ulli len);
void	ft_print_tens(char **dict, char **spec_tens, char *nb, t_ulli *i);
char	*ft_print_group_marker(char **dict, t_ulli *i);
int		ft_marker_and_comma(char **dict, t_ulli i, t_ulli group);

void	ft_print_next(char *str, char **dict);

char	*ft_parse_nbr(char *nbr);

int		ft_calc_part_len(char *str, int mode);
int		ft_copy_nb(char *res, char *file, int k);
int		ft_copy_value(char *res, char *file, int k);
int		ft_fill_dict(char **res, char *file, int i, int k);
char	**ft_parse_dict(char *filename);

char	*ft_read_file(char *filename);
int		ft_count_parts(char *file);
int		ft_error(char **res, char *file, int i);

char	**ft_malloc_spec_tens(char **dict);
char	**ft_fill_spec_tens(char **dict);
int		ft_is_spec_ten(char **spec_tens, char *nb);

t_ulli	ft_strlen(char *str);
void	ft_putchar(char charac);
void	ft_putstr(char *str);
int		ft_strcmp(char *s1, char *s2);
char	*ft_strndup(char *src, t_ulli n);

void	ft_free_n_arr_arr(char **arr, t_ulli n);
void	ft_free_arr_arr(char **arr);
int		ft_number_is_printable(char *number, char **dict);
char	*ft_cat(char ten, char unit);

#endif
